# Brute force code for avoidance sequences
import itertools 
def PartitionAvoids(mu, pat):
	mu = Partition(mu)
	pat = Partition(pat)
	r = mu.length()

	a = pat.length()
	b = pat.conjugate().length()

	
	R = range(0,r)
	for Y in itertools.combinations(R, a):
		nu = Partition([mu[i] for i in Y]).conjugate()

		c = nu.length()
		if c>= b:
			C = range(0,c)
			for X in itertools.combinations(C,b):
				nu2 = Partition([nu[i] for i in X]).conjugate()			

				if nu2 == pat:
					return false	

	return true

def GenAllAvoiding(pat,n):
	P = []
	for p in Partitions(n): 
		if PartitionAvoids(p,pat):
			P.append(p)
	return P	

def GetAvoidanceSequence(pat, N):
	L = []
	for n in range(1,N+1):
		x = GenAllAvoiding(pat,n)
		L.append(len(x))
	return L



#Generating function code for avoidance sequences
def GetExp(monomial):
	if monomial == 1:
		return 0
	else:
		return floor(log(monomial)(x=e))

def GFTree(L, t):

	if L != []:
		if L[0] == 'E':
			G = (GFTree(L[1:],1) - x*t*GFTree(L[1:],x*t))/(1-x*t)
			return G.full_simplify()
		else:
			if t!= 0:
				m = GetExp(t)
				G = 0
				F0 = GFTree(L[1:], 0)
				for i in range(0,m+1):
					G += GFTree(L[1:],x**i) - F0

				G = 1/(1-x**(m+1))*G + F0
				return G.full_simplify()
			else:
				return GFTree(L[1:], 0)
					
	else:
		return x*t/(1-x*t)		


def GetBoundaryDirections(mu):
	B = []

	B = B+ ['E']*(mu[-1]-1)
	B += ['NE']
	

	for i in range(len(mu)-2,0,-1):
		k = (mu[i]-mu[i+1]-1)
		B +=['E']*k
		B += ['NE']
	
	B +=['E']*((mu[0]-mu[1]-2))
		

	B.reverse()

	return B


# Nathan the procedure "Test" is what you need to run this.  
# mu must be a partition (as a list) of a super distinct partition
# N is the the number of terms you will see in the GF
def Test(mu,N):
	L = GetBoundaryDirections(mu)
	print L
	F = GFTree(L,1)
	print F.full_simplify()

	#print GetAvoidanceSequence(mu, N)
	return F.series(x,N+1).coefficients(sparse = False)[1:]









# def Get(N, k):
# 	Seq = []
# 	for n in range(1,N+1):
# 		c = 0
		
# 		for p in Partitions(n):
# 			S = set()
# 			for x in p:
# 				S.add(x)
# 			L = list(S)	
# 			L.sort()	
# 			if len(L) <=k and L[-1]- L[0]<= k-1:
# 				c+=1

# 		Seq.append(c)
# 	return Seq		

# def GetTau_GF(N):
# 	x,t = var('x,t')
# 	T = x*0

# 	for n in range(1,N+1):
# 		for d in divisors(n):
# 			T+=  t**d * x**n

# 	return T.collect(x)	

# def PartitionsDifferBy_GF(N,K):
# 	x,t = var('x,t')
# 	F0 = GetTau_GF(N)

# 	Fk = (F0(t=1) - F0(t=x*t)) / (1-x*t)
	


# 	for k in range(2,K+1):
# 		Fk = (Fk(t=1) - x*t*Fk(t=x*t)) / (1-x*t)
		

# 	return Fk(t=1).series(x,N)	
		

# def CountGeneralizedDivisionAlgorithm_GF(N,K):
# 	x = var('x')
# 	F = x**K/(1-x**K)/(1-x**K)
	
# 	for s in range(1,K):
# 		F += x**s/(1-x**s) * 1/(1-x**K)	
	
# 	return F.series(x,N+1).coefficients(sparse = False)[1:]	


# def CountGeneralizedDivisionAlgorithm_Force(n,k):
# 	c = 0
# 	for a in range(1,n+1):
# 		for r in range(0,a):
# 			if n-k*r >= a:
# 				if (n-k*r) % a == 0:
# 					c +=1 
# 					# print n, a, (n-k*r)/a, r
# 	return c
	
# def GetSequence_Force(N,k):
# 	L = []
# 	for n in range(1,N+1):
# 		L.append(CountGeneralizedDivisionAlgorithm_Force(n,k))
# 	return L




